#include "console.h"

Console::Console(unsigned int newMax)
: useCurrent(false), maxLines(newMax)
{
}

void Console::print(const char *line)
{
	std::string newLine = line;
	if (useCurrent && buffer.size())
	{
		std::string tmp = *buffer.begin();
		*buffer.begin() = line;
		buffer.push_front(tmp);
	}
	else
	{
		buffer.push_front(newLine);
	}

	while (buffer.size() > maxLines)
		buffer.pop_back();
}

std::string Console::current()
{
	if (!buffer.size() || !useCurrent)
		buffer.push_front(std::string());
	useCurrent = true;
	return *buffer.begin();
}

void Console::current(const std::string &newCurrent)
{
	if (!buffer.size() || !useCurrent)
		buffer.push_front(std::string());
	*buffer.begin() = newCurrent;
	useCurrent = true;
}

void Console::finalizeCurrent()
{
	useCurrent = false;

	while (buffer.size() > maxLines)
		buffer.pop_back();
}

std::list<std::string> &Console::data()
{
	return buffer;
}

void Console::setMaxLines(unsigned int newMax)
{
	maxLines = newMax;
}
