#ifndef MIRVSH
#define MIRVSH

#include "weapon.h"
#include "missiles.h"
#include "explosive.h"
#include "explosion.h"
#include "object.h"

class MIRVObject : public Object
{
	void explode(Physics::Environment env);
public:
	MIRVObject() : child(ExplosiveWeapon::Missile) {}
	void advanceEvent(Physics::Environment env, float advanceTime);
	void contactEvent(Physics::Environment env);
	ExplosiveWeapon child;
};

class MIRV : public Weapon
{
	unsigned int iconTexture;
	ExplosiveWeapon missile;
	SkeletonNode explosiveSkeleton;
	unsigned int explosiveTexture;
public:
	MIRV() : iconTexture(0), missile(ExplosiveWeapon::Missile) {}
	void fire(std::list<Object *> &objects, const vertex &position, const vertex &velocity);
	bool load(std::map<std::string, Mesh> &meshMap, Display &display);
	unsigned int icon() { return iconTexture; }
	const char *name() { return "MIRV"; }
};

class DeathsHeadObject : public Object
{
	void explode(Physics::Environment env);
public:
	DeathsHeadObject() : child(ExplosiveWeapon::BabyNuke) {}
	void advanceEvent(Physics::Environment env, float advanceTime);
	void contactEvent(Physics::Environment env);
	ExplosiveWeapon child;
};

class DeathsHead : public Weapon
{
	unsigned int iconTexture;
	ExplosiveWeapon payload;
	SkeletonNode explosiveSkeleton;
	unsigned int explosiveTexture;
public:
	DeathsHead() : iconTexture(0), payload(ExplosiveWeapon::BabyNuke) {}
	void fire(std::list<Object *> &objects, const vertex &position, const vertex &velocity);
	bool load(std::map<std::string, Mesh> &meshMap, Display &display);
	unsigned int icon() { return iconTexture; }
	const char *name() { return "MIRV"; }
};

#endif
