#ifndef MISSILESH
#define MISSILESH

#include "weapon.h"

#include "explosive.h"
#include "explosion.h"
#include "mesh.h"

#include <stack>

class ExplosiveWeapon : public Weapon
{
public:
	enum Type { BabyMissile, Missile, BabyNuke, Nuke };
private:
	float radius;
	float force;
	const char *weaponName;
	const char *weaponIcon;
	
	SkeletonNode explosiveSkeleton;
	SkeletonNode explosionSkeleton;
	unsigned int explosiveTexture;
	unsigned int explosionTexture;
	unsigned int iconTexture;
public:
	ExplosiveWeapon(Type t);
	void fire(std::list<Object *> &objects, const vertex &position, const vertex &velocity);
	bool load(std::map<std::string, Mesh> &meshMap, Display &display);
	const char *name() { return weaponName; }
	unsigned int icon() { return iconTexture; }
};

#endif
