#include "object.h"

#include <iostream>

unsigned int Object::ID::nextID = 0;

Object::Object()
//: objectID(nextID++)
{
	// if nextID == 0, all hope is lost.
	position.x = position.y = position.z = rotation.x = rotation.y = rotation.z = velocity.x = velocity.y = velocity.z = 0.0f;
	scale.x = scale.y = scale.z = 1.0f;
	radius = 1.0f;
	elasticity = 1.0f;
	mass = 1.0f;
	resting = false;
	timeAlive = 0.0f;
	deleted = false;
	active = true;
	fixed = false;
	immobile = false;
}

void Object::contactEvent(Physics::Environment env)
{
	std::cout << "Object::contactEvent" << std::endl;
}

void Object::advanceEvent(Physics::Environment env, float advanceTime)
{
	timeAlive += advanceTime;
}

void Object::damageEvent(Physics::Environment env, float damage)
{
	std::cout << "Object[" << objectID.id() << "]::damageEvent" << std::endl;
}
