#ifndef SKELETONH
#define SKELETONH

#include "vertex.h"
#include "tmatrix.h"

#include <vector>
#include <string>

struct SkeletonNode
{
	std::string id;
	std::string mesh;
	vertex translation;
	vertex rotation;
	vertex scale;
	std::vector<SkeletonNode> child;
};

bool load(const char *filename, SkeletonNode &skeleton);
tMatrix transformationMatrix(const SkeletonNode &skeletonNode);
bool transformVertex(const SkeletonNode &skeleton, vertex &vertex, const char *joint);
const SkeletonNode *findChildPath(const SkeletonNode &skeleton, const char *joint);
bool getTransformationMatrix(const SkeletonNode &skeleton, const char *joint, tMatrix &t);

#endif
