#ifndef WEAPONH
#define WEAPONH

#include <list>
#include <map>
#include <string>

#include "object.h"
#include "vertex.h"
#include "display.h"
#include "skeleton.h"

class Weapon
{
public:
	virtual ~Weapon() {}
	virtual void fire(std::list<Object *> &objects, const vertex &position, const vertex &velocity) = 0;
	virtual bool load(std::map<std::string, Mesh> &meshMap, Display &display) = 0;
	virtual unsigned int icon() = 0;
	virtual const char *name() = 0;
};

#endif
