#include "xmlparser.h"

#include <fstream>
#include <string>
#include <iomanip>

XMLParser::XMLParser()
{
}

bool XMLParser::parse(const char *filename)
{
	XML_Parser parser = XML_ParserCreate("UTF-8"); // Ask about this.
	XML_SetUserData(parser, reinterpret_cast<void *>(this));
	std::ifstream file(filename);
	if (!file) return false;
	std::string contents;
	file.seekg(-1, std::ios::end);
	unsigned int position = file.tellg();
	file.seekg(0, std::ios::beg);
	contents.resize(position);
	file.read(&*contents.begin(), position);
	// contents should now contain the contents of the file

	XML_SetElementHandler(parser, staticStart, staticEnd);
	XML_SetCharacterDataHandler(parser, staticData);
	
	bool result = XML_Parse(parser, &*contents.begin(), static_cast<int>(contents.size()), true) != 0;

	XML_ParserFree(parser);
	return result;
}

void XMLParser::staticStart(void *userData, const XML_Char *name, const XML_Char **atts)
{
	(reinterpret_cast<XMLParser *>(userData))->start(userData, name, atts);
}

void XMLParser::staticEnd(void *userData, const XML_Char *name)
{
	(reinterpret_cast<XMLParser *>(userData))->end(userData, name);
}

void XMLParser::staticData(void *userData, const XML_Char *s, int len)
{
	(reinterpret_cast<XMLParser *>(userData))->data(userData, s, len);
}
